#!/system/bin/sh
#
#
# Malez @2010
#
# Enable/Disable High speed network
#
VERSION=1
MODE=status

usage (){
	echo "Usage"
	echo "$0 standard/high/status"
	exit 1
}

error(){
	echo "Error : $1"
	exit 1
}

status (){

	echo "=== Network Status ==="
	grep ro.ril.hsxpa=1 /system/build.prop && MODE=standard
	grep ro.ril.hsxpa=2 /system/build.prop && MODE=high
	
	echo "network mode is set to $MODE"
	exit 0

}


for option in "$@"; do
    case $option in
         standard)
            MODE="standard"
         	
            ;;
         high)
            MODE="high"
         	   
             ;;

         status)
            MODE="status"
            
	    ;;

         -h | --help)
            usage
             ;;

          *)
            usage
            ;;
    esac
done

mount -o remount,rw /dev/block/mtdblock3 /system && echo "Done" || error "Unable to remount /system in rw mode"
if [ $MODE == "status" ]; then
	status
elif [ $MODE == "high" ]; then

    sed -i 's/ro.ril.hsxpa=1/ro.ril.hsxpa=2/g' /system/build.prop
    sed -i 's/ro.ril.gprsclass=10/ro.ril.gprsclass=12/g' /system/build.prop
    reboot	  
elif [ $MODE == "standard" ]; then
    sed -i 's/ro.ril.hsxpa=2/ro.ril.hsxpa=1/g' /system/build.prop
    sed -i 's/ro.ril.gprsclass=12/ro.ril.gprsclass=10/g' /system/build.prop
    reboot	       	
fi



