#!/system/bin/sh
#
# Malez @2010
#
# System adjustements
#

usage() {
        echo "Usage"
        echo "$0 on/status"
        exit 1


}

on() {
	sleep 180s
      #http://www.android-devs.com/?p=31
      #battery
      #echo 0 > /proc/sys/vm/swappiness #can be ignored if you dont use swap
      #echo 0 > /proc/sys/vm/dirty_expire_centisecs #can be ignored if you dont use swap
      #echo 0 > /proc/sys/vm/dirty_writeback_centisecs #can be ignored if you dont use swap
      #echo 60 > /proc/sys/vm/dirty_background_ratio
      #echo 95 > /proc/sys/vm/dirty_ratio

      #charger
      #echo 0 > /proc/sys/vm/swappiness #can be ignored if you dont use swap
      #echo 3000 > /proc/sys/vm/dirty_expire_centisecs #can be ignored if you dont use swap
      #echo 500  > /proc/sys/vm/dirty_writeback_centisecs #can be ignored if you dont use swap
      #echo 10   > /proc/sys/vm/dirty_background_ratio
      #echo 40   > /proc/sys/vm/dirty_ratio

      #By default, when Linux runs out of memory it goes through the process list
      #and starts killing off processes that it thinks are using too much memory.
      # This sysctl makes Linux kill the runaway process that made the system
      # run out of memory instead, which is usually what you want.(this will also reduce cpu time and increase battery usage).
      sysctl -w vm.oom_kill_allocating_task=1

      #Setting vfs_cache_pressure to 10 , gives more memory to cache fs dentry and inode to save cpu
      #At the default value of vfs_cache_pressure = 100 the kernel will attempt to reclaim dentries
      # and inodes at a fair rate with respect to pagecache and swapcache reclaim.
      # Decreasing vfs_cache_pressure causes the kernel to prefer to retain dentry and inode caches.
      # Increasing vfs_cache_pressure beyond 100 causes the kernel to prefer to reclaim dentries and inodes.
      sysctl -w vm.vfs_cache_pressure=10

      echo 95 > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/up_threshold
      echo 20 > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/down_differential
      echo 400000 > /sys/devices/system/cpu/cpu0/cpufreq/ondemand/sampling_rate

}

status() {

      #ps | awk '{print$10,$11}' | sort -n # will list all running softs sorted by used cpu time
      #strace -p $(pidof yourapp) # for all your running applications

      echo /proc/sys/vm/swappiness ; cat /proc/sys/vm/swappiness #can be ignored if you dont use swap
      echo /proc/sys/vm/dirty_expire_centisecs ; cat /proc/sys/vm/dirty_expire_centisecs #can be ignored if you dont use swap
      echo /proc/sys/vm/dirty_writeback_centisecs ; cat /proc/sys/vm/dirty_writeback_centisecs #can be ignored if you dont use swap
      echo /proc/sys/vm/dirty_background_ratio ; cat /proc/sys/vm/dirty_background_ratio
      echo /proc/sys/vm/dirty_ratio ; cat /proc/sys/vm/dirty_ratio


      echo /sys/devices/system/cpu/cpu0/cpufreq/ondemand/up_threshold ; cat /sys/devices/system/cpu/cpu0/cpufreq/ondemand/up_threshold
      echo /sys/devices/system/cpu/cpu0/cpufreq/ondemand/down_differential; cat /sys/devices/system/cpu/cpu0/cpufreq/ondemand/down_differential
      echo /sys/devices/system/cpu/cpu0/cpufreq/ondemand/sampling_rate; cat /sys/devices/system/cpu/cpu0/cpufreq/ondemand/sampling_rate


      sysctl vm.oom_kill_allocating_task
      sysctl vm.vfs_cache_pressure

	



}

for option in "$@"; do
    case $option in
         on)
                on
		status
                shift
                exit 0
                ;;
         status)
                status
                shift
                exit 0
                ;;
          *)
            usage
            ;;
    esac
done

usage

